extends KinematicBody2D

const SPEED = 300
const GRAVITY = 1000
const UP = Vector2(0,-1)
const JUMP_SPEED = -400

var motion = Vector2()
export var world_limit = 1250

func _physics_process(delta):
	restart()
	update_motion(delta)


func update_motion(delta):
	fall(delta)
	run()
	jump()
	move_and_slide(motion, UP)


func _process(delta):
	update_animation(motion)


func update_animation(motion):
	$AnimatedSprite.update(motion)


func fall(delta):
	if is_on_floor() or is_on_ceiling():
		motion.y = 0
	else:
		motion.y += GRAVITY * delta
	
	if position.y > world_limit:
		#end_game()
		pass


func run():
	if Input.is_action_pressed("ui_right") and not Input.is_action_pressed("ui_left"):
		motion.x = SPEED
	elif Input.is_action_pressed("ui_left") and not Input.is_action_pressed("ui_right"):
		motion.x = -SPEED
	else:
		motion.x = 0


func jump():
	if Input.is_action_pressed("ui_up") and is_on_floor():
		motion.y = JUMP_SPEED


func restart():
	if Input.is_key_pressed(KEY_ESCAPE):
		get_tree().reload_current_scene()


func end_game():
	print("Game Over")
	#get_tree().change_scene("res://Scenes/GameOver.tscn")